// Fclass.h
//
// header for Fclass.cc
//
// copyright 1998, by Thomas Weldon,
// allrights reserved
//
//
//
// Students in eegr6118 may make copies and modify them 
//for the purposes of their course  projects during spring 1996.
//Any other use of this file is prohibited.
//


#ifndef _Fclass_h

#define _Fclass_h 1


#include <stdlib.h>
#include <limits.h>
#include <iostream.h>
#include <new.h>
#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

#include "Iclass.h"

class Fclass
{

private:
	int Fxdim;		//dimensions of image
	int Fydim;
	float *Re;	//pointer to first real data (float)
	float *Im;	//pointer to first imaginary data (float)
 	char *Fname;		//name of image

public:
	Fclass();	//default constructor
	Fclass(int, int);			//partial constructor
	~Fclass();			//destructor
	Fclass(Fclass&);			// copy constructor
	static void newerr(void) 
		{cout << "Fclass.newerr not enough memory " << "\n";exit(1);}


//GET DATA FROM OBJECT

	char *name()			//return name
		{return Fname;}
	float getelre(int , int );	//get real element of array
	float getelim(int , int );	//get imag element of array


//LOAD DATA INTO OBJECT

	void setelre(int , int , float);	//set real element of array
	void setelim(int , int , float);	//set imag element of array
	void cvtimg(Iclass&);		//load image with real parts

//OPERATORS

	Fclass& operator=(Iclass&);  	//overloaded equal
	Fclass& operator=(Fclass&);  	//overloaded equal
	Fclass operator+(int);		//element adition	
	Fclass operator+(Fclass&);	//element by element sum
	Fclass operator*(Fclass&);	//element by element product	


//FFT
Fclass Fclass::fft();			//2D fft
Fclass Fclass::ifft();			//2d ifft
Fclass Fclass::transpose();		// transpose of image
Fclass Fclass::fftoned();		// subroutine used in fft()
Fclass Fclass::ifftoned();		// subroutine used in fft()
Fclass Fclass::fftoned2(int inv); 	// subroutine used in fft()



//
//
// add your functions below here 



};

#endif


